angular.module('starter.controllers', ['utils'])

.controller('AppCtrl', function($scope, $localstorage, $rootScope, $ionicLoading, $database, $timeout) {

  // Called from UI to expand/collapse submenu group
  $scope.toggleGroup = function() {
    if ($scope.shownGroup) {
      $scope.shownGroup = false;
    } else {
      $scope.shownGroup = true;
    }
  };

  // Return whether or not to show the submenu
  $scope.isGroupShown = function(group) {
    return $scope.shownGroup;
  };

  // Switch application into Full Version
  setFullVersion=function(){
      $scope.Quizversion="Full";
      window.Paid=true;
      $scope.Paid=window.Paid;
      $localstorage.set('Paid',1);
  };

  // Support function for testing only
  setFreeVersion=function(){
      $scope.Quizversion="Free";
      window.Paid=false;
      $scope.Paid=window.Paid;
      $localstorage.set('Paid',0);
  };

  //setFreeVersion(); //called when requested for debugging
  //setFullVersion(); //called when requested for debugging

  // Check if Full Version is activated
  window.Paid=$localstorage.get('Paid',0) == 1? true: false;

  // Set version based on localstorage value Paid
  if(Paid){
    setFullVersion();
  } else {
    setFreeVersion();
  }
  $scope.menu=[];
  updateMenu=function(){
    $database.getEnabledExams().then(function(res){
        //console.log(res);
        for(j=0;j<res.length;j++){
          $scope.menu.push(res[j]);
        }
     }, function(e) {
       console.log("ERROR: "+ e.message);
       return false;
     }
   );
  };

  doWaitForDB=function() {
    $timeout(function () {
      $ionicLoading.hide();
      updateMenu();
    }, 3000);
  };

  // Receive broadcast call from Store View when full version is acquired
  $scope.$on('version-updated', function(event,data){
    if (data) {
      setFullVersion();
    }
  });

  $scope.$on('menu-updated', function(event,data){
    if (data) {
      $scope.menu=[];
      updateMenu();
    }
  });

  $ionicLoading.show({
      template: '<span class="icon spin ion-loading-d"></span> Updating menu ...'
  });
  doWaitForDB();
})





.controller('HomeCtrl', function($scope, $database, $stateParams, $localstorage, $ionicPopup, $rootScope, $state) {

  var highlight, showAd, explanation;
  var userID=$localstorage.get('userID', 'QUIZ');

  // Handle pop-up alert for input username
  takeName=function() {
    $ionicPopup.prompt({
     title: 'What is your name?',
     inputPlaceholder: 'Enter your name',
     okText: 'Okay'
    }).then(function (res) {
      if(res) {
        $localstorage.set('userID', res.toUpperCase());
        $scope.user=res.toUpperCase();
        userID=$scope.user;
      } else {
        takeName();
      }
      return;
    });
  };



  if (userID === 'QUIZ') {
      takeName();
  }

  $scope.user=userID;

  // Track this view on Google Analytics
  if(window.analytics){
          window.analytics.setUserId(userID);
          window.analytics.trackView('HomeScreen');
  }
})

.controller('AboutCtrl', function($scope, $cordovaSocialSharing, $cordovaDevice, $cordovaFile, $cordovaFileTransfer, $ionicLoading, $timeout, $database) {

    refreshDBVersion=function(){
      $database.getDBVersion().
        then(function(res){
          $scope.dbVersion=res;
        },function(error) {
          console.error(error);
          return error;
      });
    };

    refreshDBVersion();

    $scope.shareAnywhere = function() {
      window.plugins.socialsharing.available(function(isAvailable) {
      // the boolean is only false on iOS < 6
        if (isAvailable) {
          console.log('Social Sharing Plugin Activated');
          window.plugins.socialsharing.share('I\'m learning to interpret ECG by doing quizzes in ECG Master App','Improving my ECG reading skills with ECG Master App',null,'http://www.imedical-apps.com');
        }
      });
    };

    // Trigger InAppBrowser with the url value from HTML ng-click
    $scope.showURL=function(url){
       cordova.InAppBrowser.open(url,'_blank', 'location=yes');
    };

    // Trigger the downloading of new database file
    $scope.checkDB=function(){
       //First we closed database
       $database.closeDB();
       $ionicLoading.show({
           template: '<span class="icon spin ion-loading-d"></span> Checking for new database ...'
       });

       if(window.cordova){
         // name of your website database file
         var dbname = "data2.db";
         //url of database file
         var url = "";
         var path;
         var targetPath;

         var platform = $cordovaDevice.getPlatform();
         //destination folder path per platform
         if(platform == "iOS"){
           //iOS non-synch folder
           path=cordova.file.applicationStorageDirectory + "Library/LocalDatabase";
         } else {
           //Android folder
           path=cordova.file.applicationStorageDirectory + "databases";
         }
         targetPath = path + "/" + dbname; //full path to the datafile once downloaded

         var trustHosts = true;
         var options = {};

         //attempt to download the datafile
         $cordovaFileTransfer.download(url, targetPath, options, trustHosts)
         .then(function(result) {
           console.log("Database file downloaded");// Success!
           //if successed then remove the old one
           $cordovaFile.removeFile(path, "data.db")
           .then(function (success) {
             // success
             console.log("Old data.db file removed");// Success!
             $cordovaFile.moveFile(path, dbname, path, "data.db")
             .then(function (success) {
               // Initialize database with downloaded renamed filename
               db = $database.initDB("data.db");
             }, function (error){
               // Initialize database with downloaded filename
               db = $database.initDB(dbname);
             });
             $ionicLoading.show({
                 template: '<span class="icon spin ion-loading-d"></span>Downloading new database ...'
             });
             $timeout(function () {
               $ionicLoading.hide();
               refreshDBVersion();
             }, 2000);
           }, function (error) {
             // error from removing old file
             console.log("Old data.db file not removed");// Success!
             // Initialize database with downloaded database name
             db = $database.initDB(dbnane);
           });
         }, function(err) {
           console.log("Database file not downloaded");// Error
           // Initialize database with old database name
           db = $database.initDB("data.db");

           $ionicLoading.show({
               template: '<span class="icon spin ion-loading-d"></span>Try again later...'
           });
           $timeout(function () {
             $ionicLoading.hide();
             refreshDBVersion();
           }, 2000);

         }, function (progress) {
             $timeout(function () {
               $ionicLoading.show({
                   template: '<span class="icon spin ion-loading-d"></span> Opening database ...'
               });
             },500);
         });
       } else{
         //in browser we just open the databases
         db = $database.initDB("data.db");
       }
    };
})

.controller('StoreCtrl', function($scope, $localstorage, $state, $ionicPopup, $timeout, $ionicHistory, $rootScope) {

  var userID = $localstorage.get('userID', 'QUIZ');

    // Update HTML button text based on active version
  if(window.Paid){
    $scope.buyText="Pro Version Owned!";
  } else {
    $scope.buyText="Upgrade to Pro Version";
  }

  // Track this screen in Google Analytics
  if(window.analytics){
    window.analytics.setUserId(userID);
    window.analytics.trackView('StoreScreen');
  }

  showalert=function(title, message){
    alertPopup = $ionicPopup.alert({
        title: title,
        template: message,
        okText: 'Close'
    });

    $ionicHistory.nextViewOptions({
      historyRoot: true
    });

    alertPopup.then(function(res) {
      $timeout(function () {
        $state.go('app.home');
      }, 150);
    });
  };

  $scope.storeBuy=function(){
    //console.log(window.Paid, $localstorage.get('Paid'));
    if(!window.Paid && $localstorage.get('Paid') == '0') {
      console.log('Triggered button');
      window.iap.purchaseProduct('ecg_full_version', function(result){
        console.log("purchaseProduct");
        window.Paid=true;
        $scope.buyText="Pro Version Owned!";
        $rootScope.$broadcast("version-updated", true);
        $localstorage.set('Paid',1);
        showalert('Pro Version Unlocked','Thanks for purchasing ECG Master Pro Version!');
      }, function(error){
        showalert('Transaction is not completed','Please try again later...');
        console.log("error in purchase action: " + error);
      });
    }
  };

  $scope.storeRestore=function(){
    window.iap.restorePurchases(function(result){
      //console.log(JSON.stringify(result));
      var p = result[0];

      // console.log("productId: "+p['productId']);
      if(p['productId'] == 'ecg_full_version') {
        window.Paid=true;
        $scope.buyText="Pro Version Owned!";
        $rootScope.$broadcast("version-updated", true);
        $localstorage.set('Paid',1);
        showalert('Purchase restored successfully','You\'ve unlocked ECG Master Pro Version!');
      }
    }, function(error){
      showalert('Oups..!' ,'You don\'t have any purchase to restore.');
      console.log("error in restore action: " + error);
    });
  };

})

.controller('ProgressesCtrl', function($scope, $state, $ionicPopup, $timeout, $ionicHistory, $localstorage, $database){

  $ionicHistory.clearCache();

  $scope.progresses=[];

  var userID = $localstorage.get('userID', 'QUIZ');
  $database.getProgressesByUserId(userID).then(function (result) {
      if(result.length>0){
        for(i=0;i<result.length;i++){
          $scope.progresses.push(result[i]);
        }
      } else {
        $scope.progresses="";
        alertPopup = $ionicPopup.alert({
          title: "No records found",
          template: userID + ', you don\'t have yet any score recorded',
          okText: 'Close'
        });
        $ionicHistory.nextViewOptions({
              historyRoot: true
        });
        console.log("No results found for progress");
        alertPopup.then(function(res) {
          $timeout(function () {
            $ionicHistory.nextViewOptions({
              historyRoot: true
            });
            $state.go('app.home');
          }, 250);
        });
      }
  });
})

.controller('ProgressCtrl', function($scope, $ionicHistory, $database, $stateParams, $ionicPopup, $timeout, $state, $localstorage) {

  // // Reset caching
  // $ionicHistory.clearHistory();
  $ionicHistory.clearCache();

  var userID = $localstorage.get('userID', 'QUIZ');
  var LSR = 8; //this variable defines the max quantity of records in the chart. In this case last 8 records.
  var examId=$stateParams.id;

  $scope.title=$stateParams.title;
  // Track this view on Google Analytics
  if(window.analytics){
          window.analytics.setUserId(userID);
          window.analytics.trackView('ProgressScreen');
  }

  // Initialize arrays for Chart
  $scope.labels=[];
  $scope.data=[[]];
  $scope.results=[];
  $scope.series=['Last scores'];

  // Check if there is at least one recorded exam score, otherwise alertpop shows error and back to home state
  $database.loadProgress(userID,LSR,examId).then(function(res){
    if(res.rows.length>0){
        var j=1;
        var date_tmp;
        for(i=res.rows.length; i>0; i--) {
          $scope.results.push(res.rows.item(i-1));
          //console.log(JSON.stringify($scope.results));
          $scope.labels.push(j); // load labeles for ChartJs
          $scope.data[0].push(res.rows.item(i-1).Scored); // load data serie for ChartJs
          j++;
        }
    } else {
        alertPopup = $ionicPopup.alert({
          title: "No records found",
          template: userID + ', you don\'t have yet any score',
          okText: 'Close'
        });
        $ionicHistory.nextViewOptions({
              historyRoot: true
        });
        console.log("No results found");
        alertPopup.then(function(res) {
          $timeout(function () {
            $ionicHistory.nextViewOptions({
              historyRoot: true
            });
            $state.go('app.home');
          }, 250);
        });
    }
  },function(e) {
      console.log("ERROR: "+ e.message);
  });
});
